import java.util.Random;


/**
 * 
 * Generator cisel
 * 
 * @author jsobisek@zcu.students.cz
 * @version 1.0
 *
 */
public class Generator {
	
	/**
	 * Konstructor
	 * 
	 */
	public Generator() {
		
	}
	
	/**
	 * 
	 * Ziska nahodne cislo (trojuhelnik. rozdeleni)
	 * 
	 * @param paramA
	 * @return
	 */
	public double getRandomNumber(double paramA){
		
		double randomNumber = 0;
		
		do{
			randomNumber = generateRandomNumber(paramA);
		}while (randomNumber == 0);

		return randomNumber;
	}
	
	/**
	 * Vrati nahodne cislo s trojuhelnik. rozdeleni
	 * 
	 * @return
	 */
	private double generateRandomNumber(double paramA){
		
		Random rand = new Random();
		
		double x = (2 * paramA) * rand.nextDouble();
		double z = paramA * rand.nextDouble();
		
		// jsme v prvnim intervalu (0, a)
		if (x <= paramA){
			
			// zjistim a porovnam funkcni hodnotu pro y = x
			if(z < x){
				return x;
			}
			else{
				return 0;
			}
		}
		// jsme ve druhym intervalu (a, 2a)
		else if (paramA < x){
			
			// zjistim a porovnam funkcni hodnotu pro y = |-x + 2a|
			if( z < (Math.abs(- x + 2 * paramA) )){
				return x;
			}
			else{
				return 0;
			}
		}

		return 0;
	}
}



